Ascon Pilot-BIM SDK
===============

Описание
----------
Данная документация рассматривает только типы и интерфейсы специфичные для расширений к **Pilot-BIM**.
Для получения общей информации по разработке расширений для **Pilot-BIM** необходимо обращаться к документации **Ascon Pilot SDK**.
Для разработки расширений к **Pilot-BIM** в проекте расширения должен быть установлен NuGet-пакет [Ascon.Pilot.Bim.SDK](https://www.nuget.org/packages/Ascon.Pilot.Bim.SDK/), содержащий необходимые типы и интерфейсы, описанные в данной документации.
Реализация любого интерфейса, описанного здесь, должна быть зарегистрирована через **IPilotServiceProvider** (данный интерфейс также описан в документации **Ascon Pilot SDK**) перед началом использования.

## Содержание
- [Контекстное меню](#IMenu)
    - [Контекстное меню объектов](#IMenu<IObjectNodeContext>)
- [Типы контекста для построения меню](#Context)
	- [IObjectNodeContext](#IObjectNodeContext)

<a name="IMenu"/>
### Контекстное меню ###

<a name="IMenu<IObjectNodeContext>"/>
### Интерфейс `IMenu<IObjectNodeContext>` ###
Интерфейс позволяет встраивать команды в контекстное меню объектов (в дереве объектов и на сцене).

За подробным описанием интерфейса `IMenu<TMenuContext>` необходимо обращаться к документации **Ascon Pilot SDK**.

<a name="Context"/>
### Типы контекста для построения меню ###

<a name="IObjectNodeContext"/>
#### Интерфейс `IObjectNodeContext` ####
Чтобы встроить команды в контекстное меню объектов (в дереве объектов и на сцене) используйте данный тип контекста.

Описание свойств контекста:
 - `Guid ObjectNodeId { get; }` - идентификатор объекта;
 - `ReadOnlyDictionary<string, object> Attributes { get; }` - атрибуты объекта/части модели.