﻿using System;
using Ascon.Pilot.DataClasses;
using Ascon.Pilot.Server.Api.Contracts;

namespace Pilot.Xps.Connection.Client
{
    interface ICallbackListener
    {
        void UpdateCommandResult(Guid requestId, byte[] data, ServerCommandResult result);
    }

    class ServerCallback : IServerCallback
    {
        private ICallbackListener _listener;

        public ServerCallback()
        {
            
        }

        public void SetCallback(ICallbackListener listener)
        {
            _listener = listener;
        }

        public void NotifyChangeset(DChangeset changeset)
        {
            if (_listener == null)
                return;
        }

        public void NotifyOrganisationUnitChangeset(OrganisationUnitChangeset changeset)
        {
            if (_listener == null)
                return;
        }

        public void NotifyPersonChangeset(PersonChangeset changeset)
        {
            if (_listener == null)
                return;
        }

        public void NotifyDMetadataChangeset(DMetadataChangeset changeset)
        {
            if (_listener == null)
                return;
        }

        public void NotifySearchResult(DSearchResult searchResult)
        {
            if (_listener == null)
                return;
        }

        public void NotifyGeometrySearchResult(DGeometrySearchResult searchResult)
        {
            if (_listener == null)
                return;
        }

        public void NotifyDNotificationChangeset(DNotificationChangeset changeset)
        {
            if (_listener == null)
                return;
        }

        public void NotifyCommandResult(Guid requestId, byte[] data, ServerCommandResult result)
        {
            _listener?.UpdateCommandResult(requestId, data, result);
        }
    }
}
